"use strict";
/********************************************************************************
 * Copyright (C) 2018 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var common_1 = require("@theia/filesystem/lib/common");
var browser_1 = require("@theia/core/lib/browser");
var uri_1 = require("@theia/core/lib/common/uri");
var workspace_service_1 = require("@theia/workspace/lib/browser/workspace-service");
var git_repository_tracker_1 = require("./git-repository-tracker");
var problem_manager_1 = require("@theia/markers/lib/browser/problem/problem-manager");
var common_2 = require("../common");
var auth_service_1 = require("@quarks/auth-extension/lib/browser/auth-service");
var GADService = /** @class */ (function () {
    function GADService(gitRepositoryTracker, storageService, fileSystem, workspaceService, gad, authService, messageService, problemManager) {
        this.gitRepositoryTracker = gitRepositoryTracker;
        this.storageService = storageService;
        this.fileSystem = fileSystem;
        this.workspaceService = workspaceService;
        this.gad = gad;
        this.authService = authService;
        this.messageService = messageService;
        this.problemManager = problemManager;
        this.toDispose = new core_1.DisposableCollection();
        this.selectedFeatureStorageKey = 'quarks-selected-feature';
        this.workspaceFeaturesStorageKey = 'quarks-workpace-features';
        this.onFeatureChangeEmitter = new core_1.Emitter();
        this.onFeatureChange = this.onFeatureChangeEmitter.event;
        this.onBuildEmitter = new core_1.Emitter();
        this.onBuild = this.onBuildEmitter.event;
        this.onDeployEmitter = new core_1.Emitter();
        this.onDeploy = this.onDeployEmitter.event;
    }
    GADService.prototype.isDeploying = function () {
        return this.deploying;
    };
    GADService.prototype.isBuilding = function () {
        return this.building;
    };
    GADService.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.gitRepositoryTracker.onDidChangeRepository(function (repository) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!repository) return [3 /*break*/, 2];
                                        return [4 /*yield*/, this.loadFeature(repository.localUri)];
                                    case 1:
                                        _a.sent();
                                        this.storageService.setData(this.selectedFeatureStorageKey, this._selectedFeature);
                                        this.fireFeatureChange(this.selectedFeature);
                                        _a.label = 2;
                                    case 2: return [2 /*return*/];
                                }
                            });
                        }); });
                        this.gitRepositoryTracker.onGitEvent(function (event) { return __awaiter(_this, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = this;
                                        return [4 /*yield*/, this.loadFeature(event.source.localUri)];
                                    case 1:
                                        _a._selectedFeature = _b.sent();
                                        if (this._selectedFeature) {
                                            this._selectedFeature.status = event.status;
                                        }
                                        this.storageService.setData(this.selectedFeatureStorageKey, this._selectedFeature);
                                        this.fireFeatureChange(this.selectedFeature);
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        this.onFeatureChangeEvent(function (feature) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                document.title = feature.name + ":" + feature.version;
                                return [2 /*return*/];
                            });
                        }); });
                        this.workspaceService.onWorkspaceChanged(function (event) {
                            _this.refreshFeatures();
                        });
                        this.refreshFeatures();
                        _a = this;
                        return [4 /*yield*/, this.storageService.getData(this.selectedFeatureStorageKey)];
                    case 1:
                        _a._selectedFeature = _b.sent();
                        this.fireFeatureChange(this.selectedFeature);
                        this.onBuild(function (event) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (event.type === 'end') {
                                    if (event.result === 'ok') {
                                        this.messageService.info('Build realizado com sucesso', { timeout: 60000 });
                                        this.problemManager.setMarkers(new uri_1.default(this.selectedFeature.localUri), 'BUILD', []);
                                    }
                                    else {
                                        this.problemManager.setMarkers(new uri_1.default(this.selectedFeature.localUri), 'BUILD', [{
                                                message: event.details,
                                                severity: 1,
                                                range: {
                                                    start: { line: 1, character: 1 },
                                                    end: { line: 1, character: 1 }
                                                },
                                            }]);
                                    }
                                }
                                return [2 /*return*/];
                            });
                        }); });
                        this.onDeploy(function (event) {
                            if (event.type === 'end') {
                                if (event.result === 'ok') {
                                    _this.messageService.info("Deploy realizado com sucesso. " + event.details + " ", { timeout: 60000 });
                                    _this.problemManager.setMarkers(new uri_1.default(_this.selectedFeature.localUri), 'DEPLOY', []);
                                }
                                else {
                                    _this.problemManager.setMarkers(new uri_1.default(_this.selectedFeature.localUri), 'DEPLOY', [{
                                            message: event.details,
                                            severity: 1,
                                            range: {
                                                start: { line: 1, character: 1 },
                                                end: { line: 1, character: 1 }
                                            },
                                        }]);
                                }
                            }
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    GADService.prototype.refreshFeatures = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, roots, _b, _c, root, e_1_1, _d;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        roots = [];
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 7, 8, 9]);
                        return [4 /*yield*/, this.workspaceService.roots];
                    case 2:
                        _b = __values.apply(void 0, [_e.sent()]), _c = _b.next();
                        _e.label = 3;
                    case 3:
                        if (!!_c.done) return [3 /*break*/, 6];
                        root = _c.value;
                        return [4 /*yield*/, this.fileSystem.exists(root.uri + "/.feature")];
                    case 4:
                        if (_e.sent()) {
                            roots.push(root);
                        }
                        _e.label = 5;
                    case 5:
                        _c = _b.next();
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 9:
                        if (!(roots.length > 0)) return [3 /*break*/, 11];
                        _d = this;
                        return [4 /*yield*/, Promise.all(roots.map(function (r) { return _this.loadFeature(r.uri); }))];
                    case 10:
                        _d._workspaceFeatures = _e.sent();
                        _e.label = 11;
                    case 11:
                        this.storageService.setData(this.workspaceFeaturesStorageKey, this._workspaceFeatures);
                        return [2 /*return*/];
                }
            });
        });
    };
    GADService.prototype.loadFeature = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.gad.getFeature(uri)];
                }
                catch (error) {
                    console.log(error);
                    return [2 /*return*/, new Error(error)];
                }
                return [2 /*return*/];
            });
        });
    };
    GADService.prototype.fireFeatureChange = function (feature) {
        this.onFeatureChangeEmitter.fire(feature);
    };
    GADService.prototype.lsFeatureVersions = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.gad.lsFeatureVersions(id)];
            });
        });
    };
    GADService.prototype.buildFeature = function () {
        return __awaiter(this, void 0, void 0, function () {
            var feature, user, contextId, environments, enviromentDev, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        feature = this.selectedFeature;
                        user = this.authService.getUserInfo();
                        contextId = feature.context ? feature.context.id : '';
                        this.building = true;
                        this.onBuildEmitter.fire({
                            type: 'start'
                        });
                        return [4 /*yield*/, this.gad.lsEnvironment(contextId)];
                    case 1:
                        environments = _a.sent();
                        enviromentDev = environments.find(function (env) { return env.type === 'DEVELOPMENT'; });
                        if (!enviromentDev) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.gad.buildFeature(feature, enviromentDev, user, true)];
                    case 2:
                        result = _a.sent();
                        this.building = false;
                        if (result.status === 'ok') {
                            this.onBuildEmitter.fire({
                                type: 'end',
                                result: 'ok',
                                details: result.details
                            });
                        }
                        else {
                            this.onBuildEmitter.fire({
                                type: 'end',
                                result: 'nok',
                                details: result.details
                            });
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        this.onBuildEmitter.fire({
                            type: 'end',
                            result: 'nok',
                            details: 'Não encontrado ambiente de desenvolvimento configurado'
                        });
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GADService.prototype.deployFeature = function () {
        return __awaiter(this, void 0, void 0, function () {
            var feature, user, contextId, environments, enviromentDev, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        feature = this.selectedFeature;
                        user = this.authService.getUserInfo();
                        contextId = feature.context ? feature.context.id : '';
                        this.deploying = true;
                        this.onDeployEmitter.fire({
                            type: 'start'
                        });
                        return [4 /*yield*/, this.gad.lsEnvironment(contextId)];
                    case 1:
                        environments = _a.sent();
                        enviromentDev = environments.find(function (env) { return env.type === 'DEVELOPMENT'; });
                        if (!enviromentDev) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.gad.buildFeature(feature, enviromentDev, user)];
                    case 2:
                        result = _a.sent();
                        if (!(result.status === 'ok')) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.gad.provisionFeature(feature, enviromentDev, user)];
                    case 3:
                        result = _a.sent();
                        this.deploying = false;
                        if (result.status === 'ok') {
                            this.onDeployEmitter.fire({
                                type: 'end',
                                result: 'ok',
                                details: result.details
                            });
                        }
                        else {
                            this.onDeployEmitter.fire({
                                type: 'end',
                                result: 'nok',
                                details: result.details
                            });
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        this.deploying = false;
                        this.onDeployEmitter.fire({
                            type: 'end',
                            result: 'nok',
                            details: result.details
                        });
                        _a.label = 5;
                    case 5: return [3 /*break*/, 7];
                    case 6:
                        this.deploying = false;
                        this.onDeployEmitter.fire({
                            type: 'end',
                            result: 'nok',
                            details: 'Não encontrado ambiente de desenvolvimento configurado'
                        });
                        _a.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(GADService.prototype, "onFeatureChangeEvent", {
        get: function () {
            return this.onFeatureChangeEmitter.event;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GADService.prototype, "selectedFeature", {
        get: function () {
            return this._selectedFeature || {};
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], GADService.prototype, "init", null);
    GADService = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(git_repository_tracker_1.GitRepositoryTracker)),
        __param(1, inversify_1.inject(browser_1.LocalStorageService)),
        __param(2, inversify_1.inject(common_1.FileSystem)),
        __param(3, inversify_1.inject(workspace_service_1.WorkspaceService)),
        __param(4, inversify_1.inject(common_2.GAD)),
        __param(5, inversify_1.inject(auth_service_1.AuthService)),
        __param(6, inversify_1.inject(core_1.MessageService)),
        __param(7, inversify_1.inject(problem_manager_1.ProblemManager)),
        __metadata("design:paramtypes", [git_repository_tracker_1.GitRepositoryTracker,
            browser_1.LocalStorageService, Object, workspace_service_1.WorkspaceService, Object, Object, core_1.MessageService,
            problem_manager_1.ProblemManager])
    ], GADService);
    return GADService;
}());
exports.GADService = GADService;
//# sourceMappingURL=gad-service.js.map