/********************************************************************************
 * Copyright (C) 2018 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import * as React from 'react';
import { AbstractDialog, Message, DialogProps } from '@theia/core/lib/browser';
import { DisposableCollection } from '@theia/core/lib/common';
export declare abstract class BaseDialog<T> extends AbstractDialog<T> {
    protected readonly props: DialogProps;
    protected readonly onRender: DisposableCollection;
    constructor(props: DialogProps);
    protected abstract render(): React.ReactNode;
    protected onActivateRequest(msg: Message): void;
}
//# sourceMappingURL=base-dialog.d.ts.map