/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import { GAD, FeatureVersion, Feature, Environment, Result } from '../common';
import { FileSystem } from '@theia/filesystem/lib/common';
import { User } from '@quarks/auth-extension/lib/common';
export declare class GADImpl implements GAD {
    protected readonly fileSystem: FileSystem;
    protected hosts: any;
    dispose(): void;
    constructor(fileSystem: FileSystem);
    protected init(): Promise<void>;
    lsFeatureVersions(id: string): Promise<FeatureVersion[]>;
    getFeature(uri: string): Promise<Feature>;
    importFeature(feature: Feature, user: User): Promise<Result>;
    buildFeature(feature: Feature, environment: Environment, user: User, simulate?: boolean): Promise<Result>;
    provisionFeature(feature: Feature, environment: Environment, user: User): Promise<Result>;
    newFeature(feature: Feature, user: User): Promise<Result>;
    lsEnvironment(contextId: string): Promise<Environment[]>;
}
//# sourceMappingURL=gad-impl.d.ts.map