"use strict";
/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var common_1 = require("@theia/filesystem/lib/common");
var jsoncparser = require("jsonc-parser");
var axios = require('axios');
var GADImpl = /** @class */ (function () {
    function GADImpl(fileSystem) {
        this.fileSystem = fileSystem;
    }
    GADImpl.prototype.dispose = function () {
    };
    GADImpl.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, axios.get(process.env.CONFIG_URI)];
                    case 1:
                        _a.hosts = (_b.sent()).data;
                        return [2 /*return*/];
                }
            });
        });
    };
    GADImpl.prototype.lsFeatureVersions = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var request, result_1, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = {
                            featureId: id
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios.post(this.hosts.HOST_GAD + "/feature/repositoryVersionInfo", request)];
                    case 2:
                        result_1 = _a.sent();
                        result_1 = result_1.data.versions.map(function (item) { return ({
                            version: item.version,
                            status: item.status.name,
                            description: item.status.description,
                            uri: item.checkoutTo.urlGit,
                            type: item.checkoutTo.type,
                            ref: item.checkoutTo.value,
                            allowNewVersion: result_1.data.allowNewVersion,
                            allowNewBugfix: result_1.data.allowNewBugfix
                        }); });
                        return [2 /*return*/, result_1];
                    case 3:
                        error_1 = _a.sent();
                        console.log(error_1);
                        throw new Error(error_1);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GADImpl.prototype.getFeature = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var content, featureConfig, feature, result, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.fileSystem.resolveContent(uri + "/.feature")];
                    case 1:
                        content = (_a.sent()).content;
                        featureConfig = jsoncparser.parse(content);
                        feature = {
                            localUri: uri,
                            id: featureConfig.id,
                            name: featureConfig.name,
                            version: featureConfig.version
                        };
                        return [4 /*yield*/, axios.get(this.hosts.HOST_GAD_REPOSITORY + "/feature/" + feature.id)];
                    case 2:
                        result = _a.sent();
                        feature = __assign({}, feature, { context: {
                                id: result.data.context.id
                            } });
                        return [2 /*return*/, feature];
                    case 3:
                        error_2 = _a.sent();
                        console.log(error_2);
                        return [2 /*return*/, new Error(error_2)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GADImpl.prototype.importFeature = function (feature, user) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, { status: 'ok' }];
            });
        });
    };
    GADImpl.prototype.buildFeature = function (feature, environment, user, simulate) {
        if (simulate === void 0) { simulate = false; }
        return __awaiter(this, void 0, void 0, function () {
            var request, result, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = {
                            featureId: feature.id,
                            featureName: feature.name,
                            username: user.username,
                            environmentName: environment.name,
                            simulate: simulate
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios.post(this.hosts.HOST_GAD + "/builder/build", request)];
                    case 2:
                        result = _a.sent();
                        console.log("buildFeature: " + result);
                        if (result.data.status === 'error') {
                            console.log('buildFeature:');
                            console.log(result.data.errorMessage);
                            return [2 /*return*/, {
                                    status: 'nok',
                                    details: result.data.errorMessage
                                }];
                        }
                        return [2 /*return*/, {
                                status: 'ok',
                                details: result.data.message
                            }];
                    case 3:
                        error_3 = _a.sent();
                        console.log('buildFeature:');
                        console.log(error_3);
                        return [2 /*return*/, {
                                status: 'nok',
                                details: error_3.message
                            }];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GADImpl.prototype.provisionFeature = function (feature, environment, user) {
        return __awaiter(this, void 0, void 0, function () {
            var request, result, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = {
                            featureId: feature.id,
                            featureName: feature.name,
                            username: user.username,
                            environmentId: environment.id,
                        };
                        console.log(request);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios.post(this.hosts.HOST_GAD_FS + "/feature/provisionFeature", request)];
                    case 2:
                        result = _a.sent();
                        console.log("provisionFeature: " + result);
                        if (result.data.status === 'error') {
                            console.log('provisionFeature:');
                            console.log(result.data.errorMessage);
                            return [2 /*return*/, {
                                    status: 'nok',
                                    details: result.data.errorMessage
                                }];
                        }
                        return [2 /*return*/, {
                                status: 'ok',
                                details: result.data.route
                            }];
                    case 3:
                        error_4 = _a.sent();
                        console.log('provisionFeature catch:');
                        console.log(error_4);
                        return [2 /*return*/, {
                                status: 'nok',
                                details: error_4.message
                            }];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GADImpl.prototype.newFeature = function (feature, user) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, { status: 'ok' }];
            });
        });
    };
    GADImpl.prototype.lsEnvironment = function (contextId) {
        return __awaiter(this, void 0, void 0, function () {
            var result, response, error_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, axios.get(this.hosts.HOST_GAD_REPOSITORY + "/environment/findEnvironmentByContext/" + contextId)];
                    case 1:
                        result = _a.sent();
                        response = result.data.map(function (element) { return ({
                            id: element.id,
                            name: element.name,
                            type: element.type
                        }); });
                        return [2 /*return*/, response];
                    case 2:
                        error_5 = _a.sent();
                        console.log(error_5);
                        throw new Error(error_5);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], GADImpl.prototype, "init", null);
    GADImpl = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(common_1.FileSystem)),
        __metadata("design:paramtypes", [Object])
    ], GADImpl);
    return GADImpl;
}());
exports.GADImpl = GADImpl;
//# sourceMappingURL=gad-impl.js.map